diff --git a/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java b/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
index f06687be0..244c133c8 100644
--- a/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
+++ b/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
@@ -1,41 +1,57 @@
 package net.minecraft.server.entity;
 
-import net.minecraft.core.entity.*;
-import net.minecraft.core.entity.animal.IAnimal;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.entity.projectile.*;
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
-import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.net.entity.NetEntityHandler;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet17Sleep;
+import net.minecraft.core.net.packet.Packet28EntityVelocity;
+import net.minecraft.core.net.packet.Packet29DestroyEntity;
+import net.minecraft.core.net.packet.Packet31RelEntityMove;
+import net.minecraft.core.net.packet.Packet32EntityLook;
+import net.minecraft.core.net.packet.Packet33RelEntityMoveLook;
+import net.minecraft.core.net.packet.Packet34EntityTeleport;
+import net.minecraft.core.net.packet.Packet35EntityNickname;
+import net.minecraft.core.net.packet.Packet40EntityMetadata;
+import net.minecraft.core.net.packet.Packet42EntityTagData;
+import net.minecraft.core.net.packet.Packet5PlayerInventory;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.net.packet.*;
-
-import java.util.*;
-
-// Referenced classes of package net.minecraft.src:
-//            Entity, MathHelper, Packet34EntityTeleport, Packet33RelEntityMoveLook, 
-//            Packet31RelEntityMove, Packet32EntityLook, Packet28EntityVelocity, DataWatcher, 
-//            Packet40EntityMetadata, EntityPlayerMP, NetServerHandler, Packet29DestroyEntity, 
-//            Packet5PlayerInventory, EntityPlayer, Packet17Sleep, EntityItem, 
-//            Packet21PickupSpawn, Packet20NamedEntitySpawn, EntityMinecart, Packet23VehicleSpawn, 
-//            EntityBoat, IAnimals, Packet24MobSpawn, EntityLiving, 
-//            EntityFish, EntityArrow, EntitySnowball, EntityFireball, 
-//            EntityEgg, EntityTNTPrimed, EntityFallingSand, Block, 
-//            EntityPainting, Packet25EntityPainting, Packet
+import net.minecraft.core.world.data.SynchedEntityData;
+import net.minecraft.server.entity.player.EntityPlayerMP;
 
-public class EntityTrackerEntry
-{
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
 
-    public EntityTrackerEntry(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates)
-    {
+public class EntityTrackerEntry {
+    public Entity trackedEntity;
+    public int trackingDistance;
+    public int packetDelay;
+    public int encodedPosX;
+    public int encodedPosY;
+    public int encodedPosZ;
+    public int encodedRotationYaw;
+    public int encodedRotationPitch;
+    public double lastTrackedEntityMotionX;
+    public double lastTrackedEntityMotionY;
+    public double lastTrackedEntityMotionZ;
+    public int updateCounter;
+    private double lastTrackedEntityPosX;
+    private double lastTrackedEntityPosY;
+    private double lastTrackedEntityPosZ;
+    private boolean firstUpdateDone;
+    private final boolean shouldSendMotionUpdates;
+    private int ticksSinceLastTeleport;
+    public boolean playerEntitiesUpdated;
+    public Set<EntityPlayerMP> trackedPlayers;
+    public EntityTrackerEntry(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates) {
         updateCounter = 0;
+        ticksSinceLastTeleport = 0;
         firstUpdateDone = false;
-        field_28165_t = 0;
         playerEntitiesUpdated = false;
-        trackedPlayers = new HashSet();
+        trackedPlayers = new HashSet<>();
         trackedEntity = entity;
         this.trackingDistance = trackingDistance;
         this.packetDelay = packetDelay;
@@ -48,15 +64,9 @@ public class EntityTrackerEntry
     }
 
     @Override
-	public boolean equals(Object obj)
-    {
-        if(obj instanceof EntityTrackerEntry)
-        {
-            return ((EntityTrackerEntry)obj).trackedEntity.id == trackedEntity.id;
-        } else
-        {
-            return false;
-        }
+	public boolean equals(Object obj) {
+        if (!(obj instanceof EntityTrackerEntry)) return false;
+        return ((EntityTrackerEntry)obj).trackedEntity.id == trackedEntity.id;
     }
 
     @Override
@@ -65,11 +75,9 @@ public class EntityTrackerEntry
         return trackedEntity.id;
     }
 
-    public void tick(List list)
-    {
+    public void tick(List<EntityPlayer> list) {
         playerEntitiesUpdated = false;
-        if(!firstUpdateDone || trackedEntity.distanceToSqr(lastTrackedEntityPosX, lastTrackedEntityPosY, lastTrackedEntityPosZ) > 16D)
-        {
+        if(!firstUpdateDone || trackedEntity.distanceToSqr(lastTrackedEntityPosX, lastTrackedEntityPosY, lastTrackedEntityPosZ) > 16D) {
             lastTrackedEntityPosX = trackedEntity.x;
             lastTrackedEntityPosY = trackedEntity.y;
             lastTrackedEntityPosZ = trackedEntity.z;
@@ -77,9 +85,8 @@ public class EntityTrackerEntry
             playerEntitiesUpdated = true;
             updatePlayerEntities(list);
         }
-        field_28165_t++;
-        if(++updateCounter % packetDelay == 0)
-        {
+        ticksSinceLastTeleport++;
+        if(++updateCounter % packetDelay == 0) {
             int entityX = MathHelper.floor_double(trackedEntity.x * 32D);
             int entityY = MathHelper.floor_double(trackedEntity.y * 32D);
             int entityZ = MathHelper.floor_double(trackedEntity.z * 32D);
@@ -88,142 +95,106 @@ public class EntityTrackerEntry
             int dx = entityX - encodedPosX;
             int dy = entityY - encodedPosY;
             int dz = entityZ - encodedPosZ;
-            Object obj = null;
+            Packet packet = null;
             boolean hasMoved = java.lang.Math.abs(entityX) >= 8 || java.lang.Math.abs(entityY) >= 8 || java.lang.Math.abs(entityZ) >= 8;
             boolean hasLooked = java.lang.Math.abs(entityYaw - encodedRotationYaw) >= 8 || java.lang.Math.abs(entityPitch - encodedRotationPitch) >= 8;
-            if(dx < -128 || dx >= 128 || dy < -128 || dy >= 128 || dz < -128 || dz >= 128 || field_28165_t > 400)
-            {
-                field_28165_t = 0;
+            if(dx < -128 || dx >= 128 || dy < -128 || dy >= 128 || dz < -128 || dz >= 128 || ticksSinceLastTeleport > 400) {
+                ticksSinceLastTeleport = 0;
                 trackedEntity.x = (double)entityX / 32D;
                 trackedEntity.y = (double)entityY / 32D;
                 trackedEntity.z = (double)entityZ / 32D;
-                obj = new Packet34EntityTeleport(trackedEntity.id, entityX, entityY, entityZ, (byte)entityYaw, (byte)entityPitch);
-            } else
-            if(hasMoved && hasLooked)
-            {
-                obj = new Packet33RelEntityMoveLook(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz, (byte)entityYaw, (byte)entityPitch);
-            } else
-            if(hasMoved)
-            {
-                obj = new Packet31RelEntityMove(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz);
-            } else
-            if(hasLooked)
-            {
-                obj = new Packet32EntityLook(trackedEntity.id, (byte)entityYaw, (byte)entityPitch);
+                packet = new Packet34EntityTeleport(trackedEntity.id, entityX, entityY, entityZ, (byte)entityYaw, (byte)entityPitch);
+            } else if(hasMoved && hasLooked) {
+                packet = new Packet33RelEntityMoveLook(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz, (byte)entityYaw, (byte)entityPitch);
+            } else if(hasMoved) {
+                packet = new Packet31RelEntityMove(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz);
+            } else if(hasLooked) {
+                packet = new Packet32EntityLook(trackedEntity.id, (byte)entityYaw, (byte)entityPitch);
             }
-            if(shouldSendMotionUpdates)
-            {
+            if(shouldSendMotionUpdates) {
                 double d = trackedEntity.xd - lastTrackedEntityMotionX;
                 double d1 = trackedEntity.yd - lastTrackedEntityMotionY;
                 double d2 = trackedEntity.zd - lastTrackedEntityMotionZ;
                 double d3 = 0.02D;
                 double d4 = d * d + d1 * d1 + d2 * d2;
-                if(d4 > d3 * d3 || d4 > 0.0D && trackedEntity.xd == 0.0D && trackedEntity.yd == 0.0D && trackedEntity.zd == 0.0D)
-                {
+                if(d4 > d3 * d3 || d4 > 0.0D && trackedEntity.xd == 0.0D && trackedEntity.yd == 0.0D && trackedEntity.zd == 0.0D) {
                     lastTrackedEntityMotionX = trackedEntity.xd;
                     lastTrackedEntityMotionY = trackedEntity.yd;
                     lastTrackedEntityMotionZ = trackedEntity.zd;
                     sendPacketToTrackedPlayers(new Packet28EntityVelocity(trackedEntity.id, lastTrackedEntityMotionX, lastTrackedEntityMotionY, lastTrackedEntityMotionZ));
                 }
             }
-            if(obj != null)
-            {
-                sendPacketToTrackedPlayers(((Packet) (obj)));
+            if(packet != null) {
+                sendPacketToTrackedPlayers(packet);
             }
-            SynchedEntityData datawatcher = trackedEntity.getEntityData();
-            if(datawatcher.isDirty())
-            {
-                sendPacketToTrackedPlayersAndTrackedEntity(new Packet40EntityMetadata(trackedEntity.id, datawatcher));
+            SynchedEntityData synchedEntityData = trackedEntity.getEntityData();
+            if(synchedEntityData.isDirty()) {
+                sendPacketToTrackedPlayersAndTrackedEntity(new Packet40EntityMetadata(trackedEntity.id, synchedEntityData));
             }
-            if(hasMoved)
-            {
+            if(hasMoved) {
                 encodedPosX = entityX;
                 encodedPosY = entityY;
                 encodedPosZ = entityZ;
             }
-            if(hasLooked)
-            {
+            if(hasLooked) {
                 encodedRotationYaw = entityYaw;
                 encodedRotationPitch = entityPitch;
             }
         }
-        if(trackedEntity.hurtMarked)
-        {
+        if(trackedEntity.hurtMarked) {
             sendPacketToTrackedPlayersAndTrackedEntity(new Packet28EntityVelocity(trackedEntity));
             trackedEntity.hurtMarked = false;
         }
-        if (trackedEntity.hadNicknameSet)
-        {
+        if (trackedEntity.hadNicknameSet) {
             sendPacketToTrackedPlayersAndTrackedEntity(new Packet35EntityNickname(trackedEntity.id, ((EntityLiving) trackedEntity).nickname, ((EntityLiving) trackedEntity).chatColor));
             trackedEntity.hadNicknameSet = false;
         }
     }
 
-    public void sendPacketToTrackedPlayers(Packet packet)
-    {
-        EntityPlayerMP entityplayermp;
-        for(Iterator iterator = trackedPlayers.iterator(); iterator.hasNext(); entityplayermp.playerNetServerHandler.sendPacket(packet))
-        {
-            entityplayermp = (EntityPlayerMP)iterator.next();
+    public void sendPacketToTrackedPlayers(Packet packet) {
+        for (EntityPlayerMP playerMP : trackedPlayers){
+            playerMP.playerNetServerHandler.sendPacket(packet);
         }
-
     }
 
-    public void sendPacketToTrackedPlayersAndTrackedEntity(Packet packet)
-    {
+    public void sendPacketToTrackedPlayersAndTrackedEntity(Packet packet) {
         sendPacketToTrackedPlayers(packet);
-        if(trackedEntity instanceof EntityPlayerMP)
-        {
+        if(trackedEntity instanceof EntityPlayerMP) {
             ((EntityPlayerMP)trackedEntity).playerNetServerHandler.sendPacket(packet);
         }
     }
 
-    public void sendDestroyEntityPacketToTrackedPlayers()
-    {
+    public void sendDestroyEntityPacketToTrackedPlayers() {
         sendPacketToTrackedPlayers(new Packet29DestroyEntity(trackedEntity.id));
     }
 
-    public void removeFromTrackedPlayers(EntityPlayerMP entityplayermp)
-    {
-        if(trackedPlayers.contains(entityplayermp))
-        {
-            trackedPlayers.remove(entityplayermp);
-        }
+    public void removeFromTrackedPlayers(EntityPlayerMP playerMP) {
+        trackedPlayers.remove(playerMP);
     }
 
-    public void updatePlayerEntity(EntityPlayerMP entityplayermp)
-    {
-
-        if(entityplayermp == trackedEntity)
-        {
+    public void updatePlayerEntity(EntityPlayerMP entityplayermp) {
+        if(entityplayermp == trackedEntity) {
             return;
         }
-        double d = entityplayermp.x - (double)(encodedPosX / 32);
-        double d1 = entityplayermp.z - (double)(encodedPosZ / 32);
-        if(d >= (double)(-trackingDistance) && d <= (double)trackingDistance && d1 >= (double)(-trackingDistance) && d1 <= (double)trackingDistance)
-        {
-            if(!trackedPlayers.contains(entityplayermp))
-            {
+        double dx = entityplayermp.x - (double)(encodedPosX / 32);
+        double dz = entityplayermp.z - (double)(encodedPosZ / 32);
+        if(dx >= (double)(-trackingDistance) && dx <= (double)trackingDistance && dz >= (double)(-trackingDistance) && dz <= (double)trackingDistance) {
+            if(!trackedPlayers.contains(entityplayermp)) {
                 trackedPlayers.add(entityplayermp);
-                entityplayermp.playerNetServerHandler.sendPacket(getSpawnPacket());
+                entityplayermp.playerNetServerHandler.sendPacket(NetEntityHandler.getSpawnPacket(this));
                 if (trackedEntity.sendAdditionalData) {
                     entityplayermp.playerNetServerHandler.sendPacket(new Packet42EntityTagData(trackedEntity));
                 }
-                if(shouldSendMotionUpdates)
-                {
+                if(shouldSendMotionUpdates) {
                     entityplayermp.playerNetServerHandler.sendPacket(new Packet28EntityVelocity(trackedEntity.id, trackedEntity.xd, trackedEntity.yd, trackedEntity.zd));
                 }
-                ItemStack aitemstack[] = trackedEntity.getInventory();
-                if(aitemstack != null)
-                {
-                    for(int i = 0; i < aitemstack.length; i++)
-                    {
+                ItemStack[] aitemstack = trackedEntity.getInventory();
+                if(aitemstack != null) {
+                    for(int i = 0; i < aitemstack.length; i++) {
                         entityplayermp.playerNetServerHandler.sendPacket(new Packet5PlayerInventory(trackedEntity.id, i, aitemstack[i]));
                     }
-
                 }
-                if(trackedEntity instanceof EntityPlayer)
-                {
+                if(trackedEntity instanceof EntityPlayer) {
                     EntityPlayer entityplayer = (EntityPlayer)trackedEntity;
                     if(entityplayer.isPlayerSleeping())
                     {
@@ -231,153 +202,21 @@ public class EntityTrackerEntry
                     }
                 }
             }
-        } else
-        if(trackedPlayers.contains(entityplayermp))
-        {
+        } else if(trackedPlayers.contains(entityplayermp)) {
             trackedPlayers.remove(entityplayermp);
             entityplayermp.playerNetServerHandler.sendPacket(new Packet29DestroyEntity(trackedEntity.id));
         }
     }
 
-    public void updatePlayerEntities(List list)
-    {
-        for(int i = 0; i < list.size(); i++)
-        {
-            updatePlayerEntity((EntityPlayerMP)list.get(i));
-        }
-
-    }
-
-    private Packet getSpawnPacket()
-    {
-        if(trackedEntity instanceof EntityItem)
-        {
-            EntityItem entityitem = (EntityItem)trackedEntity;
-            Packet21PickupSpawn packet21pickupspawn = new Packet21PickupSpawn(entityitem);
-            entityitem.x = (double)packet21pickupspawn.xPosition / 32D;
-            entityitem.y = (double)packet21pickupspawn.yPosition / 32D;
-            entityitem.z = (double)packet21pickupspawn.zPosition / 32D;
-            return packet21pickupspawn;
-        }
-        if(trackedEntity instanceof EntityPlayerMP)
-        {
-            return new Packet20NamedEntitySpawn((EntityPlayer)trackedEntity);
-        }
-        if(trackedEntity instanceof EntityMinecart)
-        {
-            EntityMinecart entityminecart = (EntityMinecart)trackedEntity;
-            if(entityminecart.minecartType == 0)
-            {
-                return new Packet23VehicleSpawn(trackedEntity, 10);
-            }
-            if(entityminecart.minecartType == 1)
-            {
-                return new Packet23VehicleSpawn(trackedEntity, 11);
-            }
-            if(entityminecart.minecartType == 2)
-            {
-                return new Packet23VehicleSpawn(trackedEntity, 12);
-            }
-        }
-        if(trackedEntity instanceof EntityBoat)
-        {
-            return new Packet23VehicleSpawn(trackedEntity, 1);
-        }
-        if(trackedEntity instanceof IAnimal)
-        {
-            return new Packet24MobSpawn((EntityLiving)trackedEntity);
-        }
-        if(trackedEntity instanceof EntityBobber)
-        {
-            return new Packet23VehicleSpawn(trackedEntity, 90);
-        }
-        if(trackedEntity instanceof EntityArrow)
-        {
-            EntityLiving entityliving = ((EntityArrow)trackedEntity).owner;
-            return new Packet23VehicleSpawn(trackedEntity, 60, entityliving == null ? trackedEntity.id : entityliving.id);
-        }
-        if(trackedEntity instanceof EntityCannonball)
-        {
-            EntityLiving entityliving = ((EntityCannonball)trackedEntity).owner;
-            return new Packet23VehicleSpawn(trackedEntity, 72, entityliving == null ? trackedEntity.id : entityliving.id);
-        }
-        if(trackedEntity instanceof EntitySnowball)
-        {
-            return new Packet23VehicleSpawn(trackedEntity, 61);
-        }
-        if(trackedEntity instanceof EntityFireball)
-        {
-            EntityFireball entityfireball = (EntityFireball)trackedEntity;
-            Packet23VehicleSpawn packet23vehiclespawn = new Packet23VehicleSpawn(trackedEntity, 63, 1);
-            packet23vehiclespawn.xVelocity = (int)(entityfireball.accelX * 8000D);
-            packet23vehiclespawn.yVelocity = (int)(entityfireball.accelY * 8000D);
-            packet23vehiclespawn.zVelocity = (int)(entityfireball.accelZ * 8000D);
-            return packet23vehiclespawn;
-        }
-        if(trackedEntity instanceof EntityEgg)
-        {
-            return new Packet23VehicleSpawn(trackedEntity, 62);
-        }
-        if(trackedEntity instanceof EntityPebble)
-        {
-            return new Packet23VehicleSpawn(trackedEntity, 64);
-        }
-        if(trackedEntity instanceof EntityTNT)
-        {
-            return new Packet23VehicleSpawn(trackedEntity, 50);
-        }
-        if(trackedEntity instanceof EntityFallingSand)
-        {
-            EntityFallingSand entityfallingsand = (EntityFallingSand)trackedEntity;
-            if(entityfallingsand.blockID == Block.sand.id)
-            {
-                return new Packet23VehicleSpawn(trackedEntity, 70);
-            }
-            if(entityfallingsand.blockID == Block.gravel.id)
-            {
-                return new Packet23VehicleSpawn(trackedEntity, 71);
-            }
-            if(entityfallingsand.blockID == Block.mud.id)
-            {
-                return new Packet23VehicleSpawn(trackedEntity, 73);
-            }
-        }
-        if(trackedEntity instanceof EntityPainting)
-        {
-            return new Packet25EntityPainting((EntityPainting)trackedEntity);
-        } else
-        {
-            throw new IllegalArgumentException((new StringBuilder()).append("Don't know how to add ").append(trackedEntity.getClass()).append("!").toString());
+    public void updatePlayerEntities(List<EntityPlayer> list) {
+        for (EntityPlayer player : list) {
+            updatePlayerEntity((EntityPlayerMP) player);
         }
     }
-
-    public void removeTrackedPlayerSymmetric(EntityPlayerMP entityplayermp)
-    {
-        if(trackedPlayers.contains(entityplayermp))
-        {
-            trackedPlayers.remove(entityplayermp);
-            entityplayermp.playerNetServerHandler.sendPacket(new Packet29DestroyEntity(trackedEntity.id));
+    public void removeTrackedPlayerSymmetric(EntityPlayerMP playerMP) {
+        if(trackedPlayers.contains(playerMP)) {
+            trackedPlayers.remove(playerMP);
+            playerMP.playerNetServerHandler.sendPacket(new Packet29DestroyEntity(trackedEntity.id));
         }
     }
-
-    public Entity trackedEntity;
-    public int trackingDistance;
-    public int packetDelay;
-    public int encodedPosX;
-    public int encodedPosY;
-    public int encodedPosZ;
-    public int encodedRotationYaw;
-    public int encodedRotationPitch;
-    public double lastTrackedEntityMotionX;
-    public double lastTrackedEntityMotionY;
-    public double lastTrackedEntityMotionZ;
-    public int updateCounter;
-    private double lastTrackedEntityPosX;
-    private double lastTrackedEntityPosY;
-    private double lastTrackedEntityPosZ;
-    private boolean firstUpdateDone;
-    private boolean shouldSendMotionUpdates;
-    private int field_28165_t;
-    public boolean playerEntitiesUpdated;
-    public Set trackedPlayers;
 }
diff --git a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java b/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
index 5ffdfc737..a879c59f6 100644
--- a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
+++ b/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
@@ -4,17 +4,10 @@ import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockPortal;
 import net.minecraft.core.block.entity.*;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.crafting.ICrafting;
 import net.minecraft.core.entity.*;
-import net.minecraft.core.entity.animal.EntityPig;
-import net.minecraft.core.entity.animal.EntityWolf;
-import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.projectile.EntityArrowGolden;
-import net.minecraft.core.entity.projectile.EntityCannonball;
-import net.minecraft.core.entity.projectile.EntityFireball;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemComplex;
@@ -35,13 +28,13 @@ import net.minecraft.core.player.inventory.*;
 import net.minecraft.core.player.inventory.slot.SlotCrafting;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.DamageType;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.core.world.chunk.ChunkCoordinate;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.server.MinecraftServer;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.HashSet;
@@ -188,7 +181,7 @@ public class EntityPlayerMP extends EntityPlayer implements ICrafting {
     }
 
     @Override
-	public ItemStack[] getInventory()
+	public @Nullable ItemStack @Nullable [] getInventory()
     {
         return playerInventory;
     }
diff --git a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
index 82434c3b3..2f341f0d7 100644
--- a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
@@ -399,7 +399,7 @@ public class NetServerHandler extends NetHandler
             playerEntity.playerController.startMining(x, y, z, packet.side);
         } else if(packet.status == 1) {
             // Hit Block
-            playerEntity.playerController.hitBlock(x, y, z, packet.side);
+            playerEntity.playerController.hitBlock(x, y, z, packet.side, packet.xHit, packet.yHit);
         } else if(packet.status == 2) {
             // Block Destroy
             if(!playerEntity.playerController.destroyBlock(x, y, z)) {
diff --git a/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 669d3bda7..c15cdb159 100644
--- a/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -64,11 +64,11 @@ public class ServerPlayerController
 		}
 	}
     
-	public void hitBlock(int x, int y, int z, Side side) {
+	public void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		thisWorld.onBlockHit(player, x, y, z, side);
 		Block block = thisWorld.getBlock(x, y, z);
 		if(block != null) {
-			block.onBlockClicked(thisWorld, x, y, z, player);
+			block.onBlockLeftClicked(thisWorld, x, y, z, player, side, xHit, yHit);
 		}
 	}
 
@@ -169,7 +169,7 @@ public class ServerPlayerController
         int i1 = world.getBlockId(i, j, k);
         if ((entityplayer.isSneaking() && entityplayer.getCurrentEquippedItem() == null) || (!entityplayer.isSneaking()))
         {
-            if (i1 > 0 && Block.blocksList[i1].blockActivated(world, i, j, k, entityplayer))
+            if (i1 > 0 && Block.blocksList[i1].onBlockRightClicked(world, i, j, k, entityplayer, side, xPlaced, yPlaced))
             {
                 return true;
             }
